var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
__export(exports, {
  BookType: () => BookType,
  default: () => stdin_default,
  myApiClient: () => myApiClient
});
var import_endpoint = __toModule(require("./endpoint"));
var import_standalone = __toModule(require("prettier/standalone"));
var import_parser_graphql = __toModule(require("prettier/parser-graphql"));
const formatGraphQL = (query) => (0, import_standalone.format)(query, { parser: "graphql", plugins: [import_parser_graphql.default] });
const BookType = {
  dolor: "DOLOR",
  ipsum: "IPSUM",
  sit: "SIT"
};
const typesTree = {
  Query: {
    get booksWithOptionalParams() {
      return {
        __args: {
          params: "BookSearchParamsAllOptional!"
        }
      };
    },
    get booksWithRequiredParams() {
      return {
        __args: {
          params: "BookSearchParamsSomeRequired!"
        }
      };
    },
    get failingQuery() {
      return {
        __args: {
          id: "String!"
        }
      };
    }
  }
};
let verbose = false;
let headers = {};
let url = "http://localhost:4123/graphql";
let retryConfig = {
  max: 0,
  before: void 0,
  waitBeforeRetry: 0
};
let responseListeners = [];
let apiEndpoint = (0, import_endpoint.getApiEndpointCreator)({
  getClient: () => ({ url, headers, retryConfig }),
  responseListeners,
  maxAge: 3e4,
  verbose,
  typesTree,
  formatGraphQL
});
const myApiClient = {
  addResponseListener: (listener) => responseListeners.push(listener),
  setHeader: (key, value) => {
    headers[key] = value;
  },
  setHeaders: (newHeaders) => {
    headers = newHeaders;
  },
  setRetryConfig: (options) => {
    if (!Number.isInteger(options.max) || options.max < 0) {
      throw new Error("retryOptions.max should be a non-negative integer");
    }
    retryConfig = {
      max: options.max,
      waitBeforeRetry: options.waitBeforeRetry,
      before: options.before
    };
  },
  setUrl: (_url) => url = _url,
  queries: {
    booksWithOptionalParams: apiEndpoint("query", "booksWithOptionalParams"),
    booksWithRequiredParams: apiEndpoint("query", "booksWithRequiredParams"),
    failingQuery: apiEndpoint("query", "failingQuery")
  },
  mutations: {}
};
var stdin_default = myApiClient;
